package net.jcip.annotations;
import java.lang.annotation.*;

/*
 * Copyright (c) 2005 Brian Goetz and Tim Peierls
 * Udostpnione na licencji Creative Commons Attribution License
 *   (http://creativecommons.org/licenses/by/2.5)
 * Oficjalna witryna: http://www.jcip.net
 *
 * Dowolna ponowna publikacja lub praca zalena dystrybuowana w postaci kodu rdowego
 * Musi zawierac powysza informacj o prawach autorskich i licencji.
 */


/**
 * Klasa zawierajca t adnotacj nie jest bezpieczna wtkowo.
 * Adnotacj stosuje si, by jawnie wskaza, i klasa nie jest zabezpieczona wtkowo, cho
 * kotas mgby tak przypuszcza momimo tego, e takie bezpodstawne zaoenia s
 * wyjtkowo zym pomysem.
 * @see ThreadSafe
 */
@Documented
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface NotThreadSafe {
}
