package net.jcip.examples;

import net.jcip.annotations.*;

/**
 * Counter
 * <p/>
 * Prosty licznik bezpieczny wtkowo stosujcy wzorzec monitora.
 *
 * @author Brian Goetz and Tim Peierls
 */
@ThreadSafe
public final class Counter {
    @GuardedBy("this") private long value = 0;

    public synchronized long getValue() {
        return value;
    }

    public synchronized long increment() {
        if (value == Long.MAX_VALUE)
            throw new IllegalStateException("przepenienie licznika");
        return ++value;
    }
}
